/*
 * Arduino.......Minitel
 * GND...........GND
 * TX1...........RX
 * RX1...........TX (through 1kohm, with 2kohm pull-up)
 */

const int BAUDRATE = 1200;

void setup() {
  Serial.begin(1200);
  Serial1.begin(BAUDRATE);
}

void loop() {
  while(Serial.available() > 0) {
    Serial1.write(encode(Serial.read()));
  }
  while(Serial1.available() > 0) {
    Serial.write(minitel_decode(Serial1.read()));
  }
}

unsigned char encode(unsigned char c) {
  return c | ((((c^(c>>1)^(c>>2)^(c>>3)^(c>>4)^(c>>5)^(c>>6))&1))<<7);
}

void encode(unsigned char* s, unsigned int n) {
  for(unsigned i = 0; i < n; i ++) {
    s[i] = encode(s[i]);
  }
}

void encode(String* s) {
  for(unsigned i = 0; i < s->length(); i ++) {
    s->setCharAt(i, encode(s->charAt(i)));
  }
}

unsigned char minitel_decode(unsigned char c) {
  return c & 0x7f;
}
